# Class AsciiTableWriter

java.lang.Object
uk.ac.starlink.table.formats.DocumentedStreamStarTableWriter
uk.ac.starlink.table.formats.AbstractTextTableWriter
uk.ac.starlink.table.formats.AsciiTableWriter

All Implemented Interfaces:
  `Documented, DocumentedIOHandler, StarTableWriter`

public class AsciiTableWriter extends AbstractTextTableWriter
A StarTableWriter which outputs text to a simple format machine-readable text file. This format is suitable for reading using `AsciiStarTable` and `AsciiTableBuilder`.

Since:
  29 Mar 2004
Author:
  Mark Taylor (Starlink)

## Constructor Summary

Constructors
Constructor
Description
`AsciiTableWriter()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`docIncludesExample()`
Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
`protected String`
`formatValue(Object val, ValueInfo vinfo, int width)`
Formats a data value for output.
`String`
`getFormatName()`
Returns "ascii".
`String`
`getXmlDescription()`
Returns user-directed documentation in XML format.
`protected void`
`printColumnHeads(OutputStream strm, int[] colwidths, ColumnInfo[] cinfos)`
Outputs headings for the table columns.
`protected void`
`printLine(OutputStream strm, int[] colwidths, String[] data)`
Outputs a line of table data.
`protected void`
`printParam(OutputStream strm, String name, String value, Class<?> clazz)`
Outputs a parameter and its value.
`protected void`
`printSeparator(OutputStream strm, int[] colwidths)`
Outputs a decorative separator line, of the sort you might find between the column headings and the table data.

### Methods inherited from class AbstractTextTableWriter

`getBytes, getMaximumParameterLength, getMaxWidth, getMimeType, getMinNameWidth, getSampledRows, getWriteParameters, setMaximumParameterLength, setMaxWidth, setSampledRows, setWriteParameters, writeStarTable`

### Methods inherited from class DocumentedStreamStarTableWriter

`getExtensions, looksLikeFile, writeStarTable`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface DocumentedIOHandler

`readText`

## Constructor Details

### AsciiTableWriter

public AsciiTableWriter()

## Method Details

### formatValue

protected String formatValue(Object val, ValueInfo vinfo, int width)
Description copied from class: `AbstractTextTableWriter`
Formats a data value for output.

Specified by:
  `formatValue` in class `AbstractTextTableWriter`
Parameters:
  `val` - the value
  `vinfo` - the metadata object describing `val`'s type
  `width` - maximum preferred width into which the value should be formatted
Returns:
  formatted string meaning `value`, preferably no longer than `width` characters

### getFormatName

public String getFormatName()
Returns "ascii".

Specified by:
  `getFormatName` in interface `StarTableWriter`
Overrides:
  `getFormatName` in class `AbstractTextTableWriter`
Returns:
  output format

### docIncludesExample

public boolean docIncludesExample()
Description copied from interface: `DocumentedIOHandler`
Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.

Returns:
  true if the user documentation would benefit from the addition of an example serialization

### getXmlDescription

public String getXmlDescription()
Description copied from interface: `Documented`
Returns user-directed documentation in XML format.

The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

Returns:
  XML description of this object

### printSeparator

protected void printSeparator(OutputStream strm, int[] colwidths)
Description copied from class: `AbstractTextTableWriter`
Outputs a decorative separator line, of the sort you might find between the column headings and the table data.

Specified by:
  `printSeparator` in class `AbstractTextTableWriter`
Parameters:
  `strm` - stream to write into
  `colwidths` - column widths in characters

### printLine

protected void printLine(OutputStream strm, int[] colwidths, String[] data) throws IOException
Description copied from class: `AbstractTextTableWriter`
Outputs a line of table data.

Specified by:
  `printLine` in class `AbstractTextTableWriter`
Parameters:
  `strm` - stream to write into
  `colwidths` - column widths in characters
  `data` - array of strings to be output, one per column
Throws:
  `IOException`

### printColumnHeads

protected void printColumnHeads(OutputStream strm, int[] colwidths, ColumnInfo[] cinfos) throws IOException
Description copied from class: `AbstractTextTableWriter`
Outputs headings for the table columns.

Specified by:
  `printColumnHeads` in class `AbstractTextTableWriter`
Parameters:
  `strm` - stream to write into
  `colwidths` - column widths in characters
  `cinfos` - array of column headings
Throws:
  `IOException`

### printParam

protected void printParam(OutputStream strm, String name, String value, Class<?> clazz) throws IOException
Description copied from class: `AbstractTextTableWriter`
Outputs a parameter and its value.

Specified by:
  `printParam` in class `AbstractTextTableWriter`
Parameters:
  `strm` - stream to write into
  `name` - parameter name
  `value` - formatted parameter value
  `clazz` - type of value
Throws:
  `IOException`